#include <stdio.h>
#include <stdarg.h>
#include <pwd.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>
#include "tcron.h"


static void print_int(FILE *fw, int i)
{
    if (i==STAR)
      fprintf(fw,"*");
    else
      fprintf(fw,"%d",i);
}


static void printArr(FILE *fw, cron_t *arr, int arrN)
{
  int i;

  print_int(fw,arr[0]);

  for(i=1;i<arrN;i++) {
    if (arr[i]==STAR)
      fprintf(fw,",*");
    else
      fprintf(fw,",%d",arr[i]);
  }

  fprintf(fw," ");
}

void print_cronent(FILE *fw, CRON_ENT *pcr, char *apId)
{
      int j;

  if (apId) {
    fprintf(fw,"!%s",apId);

    if (pcr->apData)
      fprintf(fw,":%s ",pcr->apData);
    else
      fprintf(fw," ");
  }

  if (pcr->dayweekArr[0] > 2000)
    fprintf(fw,"@ ");

  printArr(fw,pcr->minArr,pcr->minArrN);
  printArr(fw,pcr->hourArr,pcr->hourArrN);
  printArr(fw,pcr->daymonArr,pcr->daymonArrN);
#if 0
  for(j=0;j<pcr->monArrN;j++) {
    if (pcr->monArr[j] != STAR)
      pcr->monArr[j]++;
  }
#endif
  printArr(fw,pcr->monArr,pcr->monArrN);
  printArr(fw,pcr->dayweekArr,pcr->dayweekArrN);

  fprintf(fw,"%s\n",pcr->cmd);
}
