#include <stdio.h>
#include <stdarg.h>
#include <pwd.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>
#include "tcron.h"


void tcrontab_list(char *apId, CRON_ENT **pcrArr_r, int *pcrArrN_r)
{

  FILE *fp;
  char cmd[4096];

  if (!apId)
    p_err("tcrontab_list: must provide apId");

  snprintf(cmd,sizeof(cmd), TCRONTAB_AP_LIB "/tcrontab-ap -l %s",apId);

  if ((fp=popen(cmd,"r"))==NULL) {
    p_err("cannot execute %s",cmd);
  }

  *pcrArrN_r = tcron_parse_file_fp(fp,pcrArr_r, apId, 0);
}


FILE *tcrontab_update_open(char *apId)
{
  FILE *fp;
  char cmd[4096];

  if (!apId)
    p_err("tcrontab_update_fp: must provide apId");

  snprintf(cmd,sizeof(cmd), TCRONTAB_AP_LIB "/tcrontab-ap -u %s", apId);

  if ((fp=popen(cmd,"w"))==NULL) {
    p_err("cannot execute %s",cmd);
  }

  return fp;
}


void tcrontab_update(char *apId, CRON_ENT *pcrArr, int pcrArrN)
{
  FILE *fp;
  char cmd[4096];

  fp = tcrontab_update_open(apId);

  int i;

  for (i=0;i<pcrArrN;i++) {
    print_cronent(fp,&pcrArr[i],apId);
  }

  fclose(fp);
}


void tcrontab_update_append(FILE *fp, char *text)
{
  fprintf(fp, "%s\n", text);
}


void tcrontab_update_close(FILE *fp)
{
  fclose(fp);
}

void tcrontab_remove(char *apId)
{
  FILE *fp;
  char cmd[4096];

  if (!apId)
    p_err("tcrontab_remove: must provide apId");

  snprintf(cmd,sizeof(cmd), TCRONTAB_AP_LIB "/tcrontab-ap -r %s",apId);
  system(cmd);
}


char *bin2text(char *p, int plen)
{
  char *bf=NULL;
  int bfN=0;
  int i;

  for (i=0;i<plen;) {
    char c = p[i];
    char t[5];
    int tN;

    t[0]='\\';
    tN=2;

    if (!c) {
      int cnt=0;

      while (i < plen && !p[i] && cnt<99) {
        i++;
        cnt++;
      }

      t[1]='z';
      sprintf(&t[2],"%02d", cnt);

      tN = 4;
    } else {
    if (c == '\n') {
      t[1]='n';
      i++;
    } else
    if (c == '\\') {
      t[1]='\\';
      i++;
    } else
    if (c == ' ') {
      t[1]='_';
      i++;
    } else
    if (c == '\t') {
      t[1]='t';
      i++;
    } else
      t[0] = c;
      tN = 1;
      i++;
    }


    bf = realloc(bf, bfN + tN);

    memcpy(bf+bfN, t, tN);

    bfN+=tN;
  }

  return bf;
}


int text2bin(char *s, char **t)
{
  char *bf=NULL;
  int bfN=0;

  while (*s) {
    char t[100];
    int tN;
    char c =  *s;

    tN=1;
    if (c=='\\' && *(s+1)) {
      char d = *(s+1);
      switch (d) {
        case '\\':
          t[0]='\\';
          break;
          s+=2;
        case 'n':
          t[0]='\n';
          s+=2;
          break;
        case 't':
          t[0]='\t';
          s+=2;
          break;
        case '_':
          t[0]=' ';
          s+=2;
          break;
        case 'z':
          s+=2;
          tN = (*s - '0')*10 +  (*(s+1) - '0');
          bzero(t,tN);
          break;
      }
    }
  }
}
